SystemOrganization addCategory: #'Glamour-Helpers'!

Announcer subclass: #GLMAnnouncer
	instanceVariableNames: 'suspendAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMAnnouncer commentStamp: 'TudorGirba 1/23/2011 00:58' prior: 0!
This is a specialization of the Announcer. The main added functionality is the ability to suspend the announcements from this announcer.!

!GLMAnnouncer methodsFor: 'announce' stamp: 'TudorGirba 5/18/2011 13:41'!
announce: anAnnouncement
	self suspendAll ifTrue: [ ^ anAnnouncement asAnnouncement ].
	^ super announce: anAnnouncement! !

!GLMAnnouncer methodsFor: 'accessing' stamp: 'tg 5/24/2010 17:27'!
announcer 
	^ self! !

!GLMAnnouncer methodsFor: 'accessing' stamp: 'TudorGirba 7/10/2011 02:10'!
glmSubscriptions
	^ registry glmSubscriptions! !

!GLMAnnouncer methodsFor: 'copying' stamp: 'TudorGirba 7/11/2011 11:16'!
postCopy
	super postCopy.
	registry := registry copy.! !

!GLMAnnouncer methodsFor: 'accessing' stamp: 'TudorGirba 5/18/2011 13:45'!
resetAnnouncer
	registry reset! !

!GLMAnnouncer methodsFor: 'suspending' stamp: 'tg 2/17/2010 23:04'!
suspendAll
	^ suspendAll ifNil: [ suspendAll := false ].! !

!GLMAnnouncer methodsFor: 'suspending' stamp: 'tg 2/18/2010 00:00'!
suspendAllWhile: aBlock
	| previousSuspensionState |
	previousSuspensionState := suspendAll.
	suspendAll := true.
	aBlock value.
	suspendAll := previousSuspensionState.! !

!Association methodsFor: '*Glamour-Helpers' stamp: 'tg 10/25/2010 02:00'!
asGlamourOriginIdentifier
	^ GLMPortIdentifier new 
		paneName: self key;
		portName: self value! !

!Association methodsFor: '*Glamour-Helpers' stamp: 'tg 10/25/2010 02:01'!
asGlamourTargetIdentifier
	^ GLMPortIdentifier new 
		paneName: self key;
		portName: self value! !

!BlockClosure methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	"This is the same as valueWithPossibleArgs: from squeak. 
	Unfortunately, VW's cullValue: is incompatible." 
	 
	self numArgs = 0 ifTrue: [^self value]. 
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray]. 
	self numArgs > anArray size 
		ifTrue: 
			[^self 
				valueWithArguments: anArray , (Array new: self numArgs - anArray size)]. 
	^self 
		valueWithArguments: 
			(anArray 
				copyFrom: 1 
				to: self numArgs)! !

!Text methodsFor: '*Glamour-Helpers' stamp: 'FabrizioPerin 5/31/2010 15:04'!
glamourString
	^ self! !

!ArrayedCollection class methodsFor: '*Glamour-Helpers' stamp: 'tg 5/4/2009 22:14'!
with: anObject withAll: aCollection

	| newArray |
	newArray := self new: aCollection size + 1.
	newArray at: 1 put: anObject.
	newArray
		replaceFrom: 2
		to: newArray size
		with: aCollection.
	^newArray
	
"Array with: 1 withAll: #(2 3 4)"! !

OrderedCollection variableSubclass: #GLMMultiValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMMultiValue commentStamp: 'tg 12/19/2009 00:16' prior: 0!
GLMMultiValue is helper class that is used in #glamourValue:.!

!GLMMultiValue methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
asGlamorousArray 
	 
	^self asArray! !

!GLMMultiValue methodsFor: 'testing' stamp: 'tg 9/9/2009 01:02'!
asGlamorousMultiValue
	^ self! !

!Symbol methodsFor: '*Glamour-Helpers' stamp: 'tg 10/25/2010 02:09'!
asGlamourOriginIdentifier
	^ GLMPortIdentifier defaultOriginOf: self! !

!Symbol methodsFor: '*Glamour-Helpers' stamp: 'tg 10/25/2010 02:08'!
asGlamourTargetIdentifier
	^ GLMPortIdentifier defaultTargetOf: self! !

!Symbol methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	anArray size < 1 ifTrue: [^nil]. 
	^anArray first perform: self! !

!Boolean methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	^self! !

Object subclass: #GLMColor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMColor methodsFor: 'accessing' stamp: 'cyrilledelaunay 7/13/2011 16:51'!
cssColor

	"should return a css color code"
	^ self subclassResponsibility ! !

!GLMColor methodsFor: 'accessing' stamp: 'cyrilledelaunay 7/13/2011 16:52'!
morphicColor

	"should return an object kind of Color"
	^ self subclassResponsibility ! !

GLMColor subclass: #GLMTransparentColor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMTransparentColor methodsFor: 'accessing' stamp: 'cyrilledelaunay 7/13/2011 16:52'!
cssColor 

	^ 'transparent'! !

!GLMTransparentColor methodsFor: 'accessing' stamp: 'cyrilledelaunay 7/13/2011 16:52'!
morphicColor 

	^ Color transparent! !

Object subclass: #GLMCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMCondition commentStamp: 'TudorGirba 7/14/2011 10:53' prior: 0!
GLMCondition is the abstract class for defininf a boolean condition applied on some input arguments. It is meant to be subclassed.!

GLMCondition subclass: #GLMAllNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMAllNilCondition methodsFor: 'glamour' stamp: 'VeronicaUquillas 2/18/2011 15:11'!
glamourValueWithArgs: anArray 
	 
	^anArray allSatisfy: [:each | each isNil]! !

GLMCondition subclass: #GLMAllNotNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMAllNotNilCondition commentStamp: '<historical>' prior: 0!
Used to test if all defined arguments of a condition or not nil.

We use this as a default condition for presentations. Usually, you will want to define a condition as a block such as '[ :class :category | (class isKindOf: Class) and: [ category isKindOf: Symbol ] ]' (or something like that) but sometimes you just want to make sure that all arguments are defined. Since we do not know the number of arguments in advance, we use this class to interpret #glamourValueWithArgs: and return true if all arguments are not nil.!

!GLMAllNotNilCondition methodsFor: 'glamour' stamp: 'DamienCassou 9/10/2009 19:54'!
glamourValueWithArgs: anArray 
	 
	^anArray allSatisfy: [:each | each notNil]! !

GLMCondition subclass: #GLMSomeNotNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMSomeNotNilCondition methodsFor: 'glamour' stamp: 'tg 12/31/2009 00:22'!
glamourValueWithArgs: anArray 
	 
	^anArray anySatisfy: [:each | each notNil]! !

Object subclass: #GLMLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

GLMLogger class
	instanceVariableNames: 'nullInstance instance'!

!GLMLogger commentStamp: 'tg 5/24/2010 17:00' prior: 0!
This is the abstract class for the Glamour loggers. These classes are typically used for debugging hte highly dynamic Glamour model.!

GLMLogger class
	instanceVariableNames: 'nullInstance instance'!

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:03'!
instance
	^ instance ifNil: [
		instance := self nullInstance ]! !

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:04'!
instance: aLogger
	instance := aLogger ! !

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 16:47'!
nullInstance 
	^ nullInstance ifNil: [
		nullInstance := GLMNullLogger new ]! !

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:08'!
reset
	instance := nil! !

!GLMLogger methodsFor: 'logging' stamp: 'tg 5/24/2010 16:45'!
logAnnouncement: anAnnouncement from: aGLMObject 
	
	! !

GLMLogger subclass: #GLMMemoryLogger
	instanceVariableNames: 'announcements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMMemoryLogger commentStamp: 'tg 5/24/2010 16:59' prior: 0!
This class stores the announcements raised by the Glamour model in an ordered collection.

The collection can later be used for debugging.!

!GLMMemoryLogger methodsFor: 'accessing' stamp: 'tg 5/24/2010 17:30'!
announcements
	^ announcements! !

!GLMMemoryLogger methodsFor: 'accessing' stamp: 'tg 5/24/2010 17:30'!
announcements: anObject
	announcements := anObject! !

!GLMMemoryLogger methodsFor: 'initialize-release' stamp: 'tg 5/24/2010 16:46'!
initialize 
	announcements := OrderedCollection new! !

!GLMMemoryLogger methodsFor: 'logging' stamp: 'tg 5/24/2010 17:31'!
logAnnouncement: anAnnouncement from: aGLMObject 
	announcements add: anAnnouncement! !

GLMLogger subclass: #GLMNullLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMNullLogger commentStamp: 'tg 5/24/2010 16:58' prior: 0!
This class simply implements the Null pattern.!

Object subclass: #GLMPortIdentifier
	instanceVariableNames: 'paneName portName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMPortIdentifier commentStamp: '<historical>' prior: 0!
This class is a simple data structure to be used for identifying a port by name.!

!GLMPortIdentifier classSide methodsFor: 'instance creation' stamp: 'tg 10/25/2010 02:09'!
defaultOriginOf: aPaneName
	^ self new 
		paneName: aPaneName;
		portName: self defaultOriginPortName! !

!GLMPortIdentifier classSide methodsFor: 'accessing' stamp: 'tg 10/25/2010 02:07'!
defaultOriginPortName
	^ #selection! !

!GLMPortIdentifier classSide methodsFor: 'instance creation' stamp: 'tg 10/25/2010 02:09'!
defaultTargetOf: aPaneName
	^ self new 
		paneName: aPaneName;
		portName: self defaultTargetPortName! !

!GLMPortIdentifier classSide methodsFor: 'accessing' stamp: 'tg 10/25/2010 02:07'!
defaultTargetPortName
	^ #entity! !

!GLMPortIdentifier classSide methodsFor: 'instance creation' stamp: 'tg 11/3/2010 13:35'!
pane: aPaneName port: aPortName
	^ self new 
		paneName: aPaneName;
		portName: aPortName! !

!GLMPortIdentifier methodsFor: 'accessing' stamp: 'tg 10/25/2010 02:07'!
asGlamourOriginIdentifier
	self portName isNil ifTrue: [self portName: self class defaultOriginPortName].
	^ self ! !

!GLMPortIdentifier methodsFor: 'accessing' stamp: 'tg 10/25/2010 02:07'!
asGlamourTargetIdentifier
	self portName isNil ifTrue: [self portName: self class defaultTargetPortName].
	^ self ! !

!GLMPortIdentifier methodsFor: 'accessing' stamp: 'tg 10/25/2010 01:56'!
paneName
	^ paneName! !

!GLMPortIdentifier methodsFor: 'accessing' stamp: 'tg 10/25/2010 01:56'!
paneName: anObject
	paneName := anObject! !

!GLMPortIdentifier methodsFor: 'accessing' stamp: 'tg 10/25/2010 01:56'!
portName
	^ portName! !

!GLMPortIdentifier methodsFor: 'accessing' stamp: 'tg 10/25/2010 01:56'!
portName: anObject
	portName := anObject! !

Object subclass: #GLMPortUpdater
	instanceVariableNames: 'portSymbol valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMPortUpdater commentStamp: '<historical>' prior: 0!
This is a strategy that populates a portSymbol with the result of evaluating valueBlock.!

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	(anArray first pane port: self portSymbol) 
		value: (self valueBlock glamourValueWithArgs: anArray)! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
portSymbol 
	 
	^portSymbol! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
portSymbol: anObject 
	 
	portSymbol := anObject! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
valueBlock 
	 
	^valueBlock! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
valueBlock: anObject 
	 
	valueBlock := anObject! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
asGlamorousArray 
	 
	^Array with: self! !

!Object methodsFor: '*Glamour-Helpers' stamp: 'tg 9/9/2009 01:02'!
asGlamorousMultiValue
	^ GLMMultiValue with: self! !

!Object methodsFor: '*Glamour-Helpers' stamp: 'tg 9/12/2009 08:43'!
glamourString 
	"This method tries to circumvent the missing displayString from Squeak" 
	 
	^ (self class canUnderstand: #asString) 
		ifTrue: [self asString] 
		ifFalse: [self displayString]! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValue: anObject 
	 
	| args | 
	args := anObject asGlamorousArray. 
	^self glamourValueWithArgs: args! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	^self! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderObject: self! !

!String methodsFor: '*Glamour-Helpers' stamp: 'FabrizioPerin 5/31/2010 15:04'!
glamourString
	^ self! !
